cscript denton adofile denton
capture log close
set more off
set rmsg on
program drop _all
log using cs_denton,replace
about
which denton

// cd "/Users/sylvia/Dropbox/School/Summer RA/Denton/Testing/denton3"
use year_test.dta

****** General Checks ******
* Check: using is a new file; high frequency file exists; and generate is a nre variable. 
rcof "noi denton unem using qtr_test.dta if tin(1960, 1980), interp(consump) from(qtr_test.dta) generate(newV)" == 602
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(consump) from(qtr_NO.dta) generate(newV)" == 601
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(consump) from(qtr_test.dta) generate(inf)" ==110


****** Validate Low-frequency file ******
* Check: no gaps in the sample; there are observations in the sample; data are tsset;  no missing values in the sample.
rcof "noi denton unem using newfile.dta if year>1970 | year< 1965 , interp(consump) from(qtr_test.dta) generate(newV)" == 198
rcof "noi denton unem using newfile.dta if tin(1997, 1999), interp(consump) from(qtr_test.dta) generate(newV)" ==2000
use YearData.dta, clear
rcof "noi denton Var using newfile.dta, interp(consump) from(qtr_test.dta) generate(newV)" == 111
use year_missing.dta, clear
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(consump) from(qtr_test.dta) generate(newV)" == 416


****** Validate High-frequency file ******
* Check: indicator is an existing numeric variable; File is tsset; file not a panel* 
use year_test.dta, clear
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(nonNum) from(qtr_test.dta) generate(newV)" ==7
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(noVar) from(qtr_test.dta) generate(newV)" == 111
rcof "noi denton unem using newfile.dta, interp(Var) from(YearData.dta) generate(newV)" == 111
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(q) from(panel_test.dta) generate(newV)" ==198

* Check: low and high frequencies are different, H freq data are superset of L freq; no empty values* 
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(inf) from(year_missing.dta) generate(newV)" ==322
rcof "noi denton unem using newfile.dta, interp(consump) from(qtr_test.dta) generate(newV)" ==198
rcof "noi denton unem using newfile.dta if tin(1960, 1980), interp(consump) from(qtr_missing.dta) generate(newV)" ==416


****** Check Saved File ******
****Year to Quarter Results****
	use year_test.dta, clear
	assert _N == 49
	denton unem using YtoQcheck.dta if tin(1960, 1980), interp(consump) from(qtr_test.dta) generate(Dent)
	use YtoQcheck, clear
* Check the time period of the new file.
	qui sum qtr
	assert `r(min)' ==0
	assert `r(max)'==83
* Check both the original and interpolated series have the same totals 
	tscollap (sum) Dent (last) unem, to(y)
	assert reldif( Dent, unem)< 1e-3

	

****Quarter to Month Results****

	use qtr_test.dta, clear
	assert _N == 92
	denton consump using QtoMcheck.dta if tin(1972q1,1982q2), interp(income) from(month_test.dta) generate(Dent)
	use QtoMcheck, clear
	qui sum month
	assert `r(min)'==144
	assert `r(max)'==269
	tscollap (sum) Dent (last) consump, to(q)
	assert reldif( Dent, consump)< 1e-3


****Year to Month Results****
	use year_test.dta, clear
	assert _N ==49
	denton unem using YtoMcheck.dta if tin(1980,1990), interp(income) from(month_test.dta) generate(Dent)
	use YtoMcheck, clear
	qui sum month
	assert `r(min)'==240
	assert `r(max)'==371
	tscollap (sum) Dent (last) unem, to(y)
	assert reldif( Dent, unem)< 1e-3




****Stock Year to Quarter Results****
	use year_test.dta, clear
	denton unemST using YtoQstock.dta if tin(1960, 1980), interp(consumpST) from(qtr_test.dta) generate(DentST) stock
	use YtoQstock, clear
	qui sum qtr
	assert `r(min)' ==0
	assert `r(max)'==83
	tscollap (last) DentST (last) unemST, to(y)
	assert reldif( DentST, unemST)< 1e-3


****Stock Quarter to Month Results****
	use qtr_test.dta, clear
	denton consumpST using QtoMstock.dta if tin(1972q1,1982q2), interp(incomeST) from(month_test.dta) generate(DentST) stock
	use QtoMstock, clear
	qui sum month
	assert `r(min)' ==144
	assert `r(max)'==269
	tscollap (last) DentST (last) consumpST, to(q)
	assert reldif( DentST, consumpST)< 1e-3


****Stock Year to Month Results****
	use year_test.dta, clear
	denton unemST using YtoMstock.dta if tin(1980,1990), interp(incomeST) from(month_test.dta) generate(DentST) stock
	use YtoMstock, clear
	qui sum month
	assert `r(min)'==240
	assert `r(max)'==371
	tscollap (last) DentST (last) unemST, to(y)
	assert reldif( DentST, unemST)< 1e-3


log close
set more on
set rmsg off



